<template>
  <div>
    <!-- search bar -->
    <div class="row d-flex justify-content-center mt-5" >
      <div class=" col-4">
        <v-select class="form-control-select" v-model="searchtype"  required
              :options="[{label: 'Rechercher suivant le titre', code: 'title'}, {label: 'Rechercher suivant le résumé', code: 'summary'},
                        {label: 'Rechercher suivant le Nom d\'auteur', code: 'lastname'} ]"></v-select>
      </div>
      <div class=" col-8">
        <input class="form-control" @keyup.enter="init(0, true)" type="search" 
          placeholder="Contenu de la recherche" v-model="searchtext"/>
      </div>
    </div>

    <!-- show submissions -->
    <div class="mt-5">
      <div class="m-5" v-if="isLoading">
        <fulfilling-bouncing-circle-spinner class="mx-auto" :animation-duration="2000"
          :size="60" :color="'#005C96'"  />
      </div>
      <div v-else>
        <span v-if="submissions"> 
          <section class="section-primary t-bordered">
            <div class="container">
              <div class="row testimonial-three testimonial-three--col-three">
                  <div class="col-md-4 testimonial-three-col" v-for="(submission, i) in submissions" :key="i" >
                    <div class="testimonial-inner col-12" @click="detailSubmission(submission._id)"  v-if="submissions">
                     <div class="testimonial-image" itemprop="image" v-if="submission.author.pictures[0]" >
                        <!-- <img width="180" height="180" :src="submission.author.pictures[0]"> -->
                        <img v-if="submission.author.pictures[0]" :src="submission.author.pictures[0]" width="180" height="180" class="img-profile rounded-circle" />
                        <img v-else :src="'https://yelumi.s3.us-east-2.amazonaws.com/koala.png'" width="180" height="180" class="img-profile rounded-circle"/>
                      </div>
                      <div class="testimonial-content mt-1"> <p>{{ submission.title }}</p> </div>
                      <div class="testimonial-meta">
                        <strong class="testimonial-name" itemprop="name" >
                          {{ submission.author.firstname }} {{ submission.author.lastname }}</strong >
                        <span class="testimonial-job-title" itemprop="jobTitle">  – {{ submission.author.profession }} </span>
                      </div>
                    </div>
                  </div>
              </div>
            </div>
          </section>
        </span>
        <span v-else > <strong> <h3 class="mx-auto text-center">Aucune Soumission</h3> </strong>  </span>
      </div>
    </div>
  </div>
</template>





<script>
export default {
  data() {
    return {
      searchtext: null,
      searchtype: null,

      isLoading: false,
      // log: false,
      //role: "",

      curPage: 1,
      perPage: 100,
      sort: {},
      submissions: null,
      total: 0,
    };
  },
  mounted() {
    if (localStorage.getItem("token")) {
      this.init();
      //console.log( localStorage.getItem("adminRole") )
      //this.role = localStorage.getItem("adminRole");
    } 
  },
  methods: {
    init(page, resetParams) {
      //console.log(this.searchtype ? this.searchtype.code : this.searchtype, this.searchtext)

      if (resetParams) {
        this.curPage = 1;
      }
      let query = {
        //options: {_id: localStorage.getItem("adminRole")},
        filter: {
          text: this.searchtext ? this.searchtext : "" ,
          type: this.searchtype ? this.searchtype.code.split("+") : "",
        },
        sort: this.sort,
        page: this.curPage - 1,
        perPage: this.perPage,
      };

      if(localStorage.getItem("adminRole") === "user"){
        query.options = {author: localStorage.getItem("adminId")}
      }

      this.isLoading = true;
      this.$service.listNoLog("submissions", query, (err, data) => {
        if (err) { return console.log(err); }
        console.log('load submissions: ',data);
        if(data.submissions.length > 0){
          this.errorMessage = "";
          this.submissions = data.submissions;
          this.total = data.submissions.length;
          this.isLoading = false;
        }else{
          this.submissions = null
          this.isLoading = false;
        }
      });
    },
    detailSubmission(id) {
      this.$router.push({ path: "/detailsubmission/" + id });
    },
    makeReview(id) {
      this.$router.push({ path: "/review/" + id });
    },

    // troncateDesc(text, max) {
    //   return text.substr(0, max) + (text.length > max ? "..." : "");
    // },
  },
};
</script>





<style lang="scss" scoped>
//old css

#mapid {
  height: 600px;
}

.color-win {
  color: #6d071a;
}
.border-style {
  border: #6d071a 2px solid;
  border-radius: 10px;
}
.box-style {
  height: 100px;
  //margin: 1px ;
}

.location-pic {
  position: relative;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding-left: 3px;
  padding-right: 3px;
  margin-right: auto;
  width: 100%;
  background-color: #efefef; /*#A2A2A2;*/
  border-bottom: 1px solid rgb(23, 25, 29);
  border-top-left-radius: 8px;
  border-top-right-radius: 8px;
  /* cursor: pointer; */
  background-size: cover;
}

.item {
  /* Set the minimum height of the items to be the same as the height of the scroll-snap-container.*/
  min-height: 500px;
}

.scroll-snap-container {
  height: 600px;
  width: 450px;
}

$size-width: 650px;
$size-height: 450px;

.carousel-wrapper {
  width: $size-width * 1.3;
  height: $size-height * 1.1;
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: 5px 5px 25px 0px rgba(46, 61, 73, 0.2);
  border-radius: 20px;
  margin: 20px auto;
}

.carousel-container {
  width: $size-width;
  height: $size-height;
  overflow: hidden;
  margin: 0 auto;
}

.carousel {
  display: flex;
  width: $size-width * 4;
  animation: sliding 12s infinite;
  div {
    width: $size-width;
    height: $size-height;
    background-size: cover;
    background-position: center;
  }
  &:hover {
    animation-play-state: paused;
  }

  .image-one {
    background-image: url("https://images.unsplash.com/photo-1480936600919-bffa6b7ecf1e?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
  .image-two {
    background-image: url("https://images.unsplash.com/photo-1475053081036-c8eb31d187b3?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
  .image-three {
    background-image: url("https://images.unsplash.com/photo-1525278070609-779c7adb7b71?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
}

@keyframes sliding {
  30% {
    transform: translateX(0);
  }
  35% {
    transform: translateX(-$size-width);
  }
  65% {
    transform: translateX(-$size-width);
  }
  70% {
    transform: translateX(-$size-width * 2);
  }
  98% {
    transform: translateX(-$size-width * 2);
  }
  100% {
    transform: translateX(0);
  }
}

@media screen and (max-width: 768px) {
  $size-width: 240px;
  $size-height: 150px;
  .carousel-wrapper {
    width: $size-width * 1.3;
    height: $size-height * 1.4;
  }

  .carousel-container {
    width: $size-width;
    height: $size-height;
  }

  .carousel {
    width: $size-width * 3;
    > div {
      width: $size-width;
      height: $size-height;
    }
  }

  @keyframes sliding {
    30% {
      transform: translateX(0);
    }
    35% {
      transform: translateX(-$size-width);
    }
    65% {
      transform: translateX(-$size-width);
    }
    70% {
      transform: translateX(-$size-width * 2);
    }
    98% {
      transform: translateX(-$size-width * 2);
    }
    100% {
      transform: translateX(0);
    }
  }
}
</style>
